Remember, an issue is not the place to ask questions. You can use [Stack Overflow](http://stackoverflow.com/questions/tagged/meteor) for that, or you may want to start a discussion on the [Meteor forum](https://forums.meteor.com/).

Before you open an issue, please check if a similar issue already exists or has been closed before.

### When reporting a bug, please be sure to include the following:
- [ ] A descriptive title
- [ ] What version of Meteor you're using, and the platform(s) you're running it on
- [ ] What packages or other dependencies you're using
- [ ] The behavior you expect to see, and the actual behavior
- [ ] An *isolated* way to reproduce the behavior (example: GitHub repository with code isolated to the issue that anyone can clone to observe the problem)

See [here](https://github.com/meteor/meteor/blob/devel/Contributing.md#reporting-a-bug-in-meteor) for more detail on what is expected of a bug report.

### When you open an issue for a feature request, please add as much detail as possible:
- [ ] A descriptive title
- [ ] A description of the problem you're trying to solve, including *why* you think this is a problem
- [ ] An overview of the suggested solution
- [ ] If the feature changes current behavior, reasons why your solution is better

See [here](https://github.com/meteor/meteor/blob/devel/Contributing.md#feature-requests) for more detail on what is expected of a feature request.

### Independent core packages

We've split some packages out of meteor/meteor in order to make it easier for community members to contribute and the MDG team to maintain a slimmer core (this enables us to untie package versions from Meteor releases). Please ensure your issue is opened against the appropriate repository. Packages that have been split from core and their repositories are:

- Blaze: https://github.com/meteor/blaze
